Index: uspace/srv/vfs/vfs_ops.c
===================================================================
--- uspace/srv/vfs/vfs_ops.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/srv/vfs/vfs_ops.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -86,5 +86,5 @@
 }
 
-int vfs_op_clone(int oldfd, int newfd, bool desc)
+int vfs_op_clone(int oldfd, int newfd, bool desc, int *out_fd)
 {
 	int rc;
@@ -102,12 +102,11 @@
 
 	if (newfd != -1) {
-		/* Make sure newfd is closed. */
-		(void) vfs_fd_free(newfd);
 		/* Assign the old file to newfd. */
 		rc = vfs_fd_assign(oldfile, newfd);
+		*out_fd = newfd;
 	} else {
 		vfs_file_t *newfile;
-		int newfd = vfs_fd_alloc(&newfile, desc);
-		if (newfd >= 0) {
+		rc = vfs_fd_alloc(&newfile, desc, out_fd);
+		if (rc == EOK) {
 			newfile->node = oldfile->node;
 			newfile->permissions = oldfile->permissions;
@@ -116,5 +115,4 @@
 			vfs_file_put(newfile);
 		}
-		rc = newfd;
 	}
 	vfs_file_put(oldfile);
@@ -225,10 +223,10 @@
 
 int vfs_op_mount(int mpfd, unsigned service_id, unsigned flags,
-    unsigned instance, const char *opts, const char *fs_name, int *outfd)
+    unsigned instance, const char *opts, const char *fs_name, int *out_fd)
 {
 	int rc;
 	vfs_file_t *mp = NULL;
 	vfs_file_t *file = NULL;
-	int fd = -1;
+	*out_fd = -1;
 	
 	if (!(flags & VFS_MOUNT_CONNECT_ONLY)) {
@@ -256,7 +254,6 @@
 	
 	if (!(flags & VFS_MOUNT_NO_REF)) {
-		fd = vfs_fd_alloc(&file, false);
-		if (fd < 0) {
-			rc = fd;
+		rc = vfs_fd_alloc(&file, false, out_fd);
+		if (rc != EOK) {
 			goto out;
 		}
@@ -297,10 +294,9 @@
 		vfs_file_put(file);
 
-	if (rc != EOK && fd >= 0) {
-		vfs_fd_free(fd);
-		fd = 0;
-	}
-	
-	*outfd = fd;
+	if (rc != EOK && *out_fd >= 0) {
+		vfs_fd_free(*out_fd);
+		*out_fd = -1;
+	}
+	
 	return rc;
 }
@@ -830,7 +826,7 @@
 }
 
-int vfs_op_wait_handle(bool high_fd)
-{
-	return vfs_wait_handle_internal(high_fd);
+int vfs_op_wait_handle(bool high_fd, int *out_fd)
+{
+	return vfs_wait_handle_internal(high_fd, out_fd);
 }
 
@@ -894,9 +890,9 @@
 	
 	vfs_file_t *file;
-	int fd = vfs_fd_alloc(&file, false);
-	if (fd < 0) {
+	rc = vfs_fd_alloc(&file, false, out_fd);
+	if (rc != EOK) {
 		vfs_node_put(node);
 		vfs_file_put(parent);
-		return fd;
+		return rc;
 	}
 	assert(file != NULL);
@@ -912,5 +908,4 @@
 	fibril_rwlock_read_unlock(&namespace_rwlock);
 
-	*out_fd = fd;
 	return EOK;
 }
Index: uspace/srv/volsrv/part.c
===================================================================
--- uspace/srv/volsrv/part.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/srv/volsrv/part.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -37,4 +37,5 @@
 #include <stdbool.h>
 #include <errno.h>
+#include <str_error.h>
 #include <fibril_synch.h>
 #include <io/log.h>
@@ -271,5 +272,5 @@
 	if (rc != EOK) {
 		log_msg(LOG_DEFAULT, LVL_ERROR, "Failed registering callback "
-		    "for partition discovery (%d).", rc);
+		    "for partition discovery: %s.", str_error(rc));
 		return rc;
 	}
@@ -328,6 +329,6 @@
 	rc = volsrv_part_empty(part->svc_id);
 	if (rc != EOK) {
-		log_msg(LOG_DEFAULT, LVL_DEBUG, "vol_part_empty_part() - failed %d",
-		    rc);
+		log_msg(LOG_DEFAULT, LVL_DEBUG, "vol_part_empty_part() - failed %s",
+		    str_error(rc));
 		return rc;
 	}
@@ -348,6 +349,6 @@
 	rc = volsrv_part_mkfs(part->svc_id, fstype, label);
 	if (rc != EOK) {
-		log_msg(LOG_DEFAULT, LVL_DEBUG, "vol_part_mkfs_part() - failed %d",
-		    rc);
+		log_msg(LOG_DEFAULT, LVL_DEBUG, "vol_part_mkfs_part() - failed %s",
+		    str_error(rc));
 		fibril_mutex_unlock(&vol_parts_lock);
 		return rc;
Index: uspace/srv/volsrv/volsrv.c
===================================================================
--- uspace/srv/volsrv/volsrv.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/srv/volsrv/volsrv.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -36,4 +36,5 @@
 #include <async.h>
 #include <errno.h>
+#include <str_error.h>
 #include <io/log.h>
 #include <ipc/services.h>
@@ -70,5 +71,5 @@
 	rc = loc_server_register(NAME);
 	if (rc != EOK) {
-		log_msg(LOG_DEFAULT, LVL_ERROR, "Failed registering server (%d).", rc);
+		log_msg(LOG_DEFAULT, LVL_ERROR, "Failed registering server: %s.", str_error(rc));
 		return EEXIST;
 	}
@@ -77,5 +78,5 @@
 	rc = loc_service_register(SERVICE_NAME_VOLSRV, &sid);
 	if (rc != EOK) {
-		log_msg(LOG_DEFAULT, LVL_ERROR, "Failed registering service (%d).", rc);
+		log_msg(LOG_DEFAULT, LVL_ERROR, "Failed registering service: %s.", str_error(rc));
 		return EEXIST;
 	}
